<?php 
namespace WPUFA\classes\admin;

class UploadConfiguratorPage
{
	function __construct()
	{
		
	}
	public function render_page()
	{
		global $wpufa_option_model, $wpufa_wpml_model, $wpufa_option_model, $wpufa_html_model;
		
		wp_enqueue_style( 'wpufa-admin-common', WPUFA_PLUGIN_PATH.'/css/admin/common.css');
		wp_enqueue_style( 'wpufa-admin-toggle', WPUFA_PLUGIN_PATH.'/css/com/toggle.css');
		wp_enqueue_style( 'wpufa-admin-settings-page', WPUFA_PLUGIN_PATH.'/css/admin/upload-configurator-page.css');
		wp_enqueue_style( 'wpufa-admin-custom-fields-ui', WPUFA_PLUGIN_PATH.'/css/admin/custom-fields-ui.css');
		wp_enqueue_style('datetime-picker', WPUFA_PLUGIN_PATH.'/css/vendor/datetimepicker/default.css'); 
		wp_enqueue_style('datetime-picker-date', WPUFA_PLUGIN_PATH.'/css/vendor/datetimepicker/default.date.css'); 
		wp_enqueue_style('datetime-picker-time', WPUFA_PLUGIN_PATH.'/css/vendor/datetimepicker/default.time.css'); 
		wp_enqueue_style('van-tooltip', WPUFA_PLUGIN_PATH.'/css/vendor/vanquish/tooltip.css'); 
	
		wp_register_script( 'wpufa-configurator-page', WPUFA_PLUGIN_PATH.'/js/admin/upload-configurator-page.js', array('jquery') );	
		
		if (isset($_POST['wpufa_field_options']) || isset($_POST['wpufa_is_submit']) )
		{
			$upload_fields_options = $wpufa_option_model->set_upload_fields_options(wpufa_get_value_if_set($_POST,'wpufa_field_options', null));
		}
		else
			$upload_fields_options = $wpufa_option_model->get_upload_fields_options(); 
		
		$next_id = is_int($wpufa_option_model->get_last_upload_field_id()) ? $wpufa_option_model->get_last_upload_field_id() + 1 : 0;
		
		$langs =  $wpufa_wpml_model->get_langauges_list();
		$available_langs = array();
		foreach($langs as $lang_data)
			$available_langs[] = $lang_data['language_code'];
			
		$variables = array(
			'next_id' => $next_id,
			'confirm_delete_message' => __('Are you sure you want to delete the field?', 'wordpress-upload-files-anywhere'),
			'show_options' => __('Show options', 'wordpress-upload-files-anywhere'),
			'hide_options' => __('Hide options', 'wordpress-upload-files-anywhere'),
			'available_langs' => $available_langs,
			'security' => wp_create_nonce('wpufa_admin_field_configurator_page')
		);
		wp_localize_script( 'wpufa-configurator-page', 'wpufa', $variables );	
		wp_enqueue_script( 'wpufa-configurator-page');	
		wp_enqueue_script( 'wp-tinymce');	
		
		wp_enqueue_script( 'datetime-picker', WPUFA_PLUGIN_PATH.'/js/vendor/datetimepicker/picker.js', array('jquery'));	
		wp_enqueue_script( 'datetime-picker-date', WPUFA_PLUGIN_PATH.'/js/vendor/datetimepicker/picker.date.js', array('jquery'));	
		wp_enqueue_script( 'datetime-picker-time', WPUFA_PLUGIN_PATH.'/js/vendor/datetimepicker/picker.time.js', array('jquery'));	
		

		
		$allowed_tags = array('strong' => array());
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST'): ?>
			<div class="notice notice-success is-dismissible">
				 <p><?php esc_html_e('Saved successfully!', 'wordpress-upload-files-anywhere'); ?></p>
			</div>
		<?php endif; ?>
			
		<div id="wpufa_main_container">
			<div class="wpufa_info">
					<h3><?php esc_html_e('Info', 'wordpress-upload-files-anywhere'); ?></h3> 
					<p><?php echo wp_kses(__('Here you can add new upload field or edit the existing ones. Click the <strong>Add new</strong> button to create a new Upload field. Once done, click the <strong>Save</strong> button to save your creations!', 'wordpress-upload-files-anywhere'), $allowed_tags); ?></p> 
				</div>
				
			<form action="" method="post" >
				
				
				<div id="wpufa_upload_fields_container">
				<?php if($upload_fields_options)
						$wpufa_html_model->get_upload_field_configuration_template($upload_fields_options); ?>
				</div>
				
				<button class="button-primary wpufa_add_new_button disable_during_animation"  ><?php esc_attr_e('Add new', 'wordpress-upload-files-anywhere'); ?></button>
				<div class="spinner load_new_upload_field_spinner"></div>
			
				<p class="submit">
					<input name="wpufa_is_submit" type="submit" class="button-primary wpufa_save_button disable_during_animation" value="<?php esc_attr_e('Save', 'wordpress-upload-files-anywhere'); ?>" />
				</p>
			</form>
			
			
		</div>
		<?php
	}
}
?>