<?php 
namespace WPUFA\classes\admin;

class UploadsListPage
{
	public function __construct()
	{
		add_action( 'manage_wpufa_upload_posts_custom_column', array($this, 'manage_custom_columns'), 10, 2 );
		add_filter( 'manage_edit-wpufa_upload_columns', array($this, 'add_custom_columns'),15 ); 
	}
	public function add_custom_columns($columns)
	 {
		
	   wp_enqueue_style('wpufa-upload-list-page', WPUFA_PLUGIN_PATH.'/css/admin/upload-list-page.css'); 
		
	   $columns['user-data'] = esc_html__('User', 'woocommerce-attach-me'); 
	   $columns['user-email'] = esc_html__('Email', 'woocommerce-attach-me'); 

	   return $columns;
	}
	public function manage_custom_columns( $column, $upload_id ) 
	{
		global $wpufa_upload_model, $wpufa_user_model;
		$user_id = $wpufa_upload_model->get_user_id($upload_id );
		$user_data = $user_id ? $wpufa_user_model->get_userdata($user_id) : false;
	
		if ( $column == 'user-data' ) 
		{
			if($user_id)
			{
				if(!$user_data)
					esc_html_e('Not existing anymore', 'woocommerce-attach-me');
				else
					echo $user_data->first_name." ".$user_data->last_name;
			}
			else esc_html_e('Guest', 'woocommerce-attach-me');
		}
		if($column == 'user-email')
		{
			if(!$user_data)
					echo "";
				else
					echo $user_data->user_email;
		}
		
		
	}
}

?>