<?php 
namespace WPUFA\classes\com;

class Email
{
	public function __construct()
	{
		
	}
	public function send($upload_field_is, $options)
	{
		global $wpufa_upload_model, $wpufa_time_model, $wpufa_input_field_model;
		
		$input_field_ids = $wpufa_upload_model->get_meta($upload_field_is, "_input_field_ids");
		
		$subject = sprintf(esc_html__('New submission for %s', 'wordpress-upload-files-anywhere'), wpufa_get_value_if_set($options, 'title'));
		
		ob_start();
		foreach($input_field_ids as $input_field_id)
		{
			$type = $wpufa_upload_model->get_meta($upload_field_is, "_input_field_type_".$input_field_id);
			$label = $wpufa_upload_model->get_meta($upload_field_is, "_input_field_label_".$input_field_id);
			$raw_value = $wpufa_upload_model->get_meta($upload_field_is, '_input_field_value_'.$input_field_id);
			$value = $wpufa_input_field_model->get_value_by_type($raw_value, $type);
			
			?>
			<p>
				<label style="font-weight: bold; display: block;"><?php  echo $label; ?></label>
				<span style="display: block;"><?php echo $value; ?></span>
			</p>
			<?php			
		}
		$message =  ob_get_contents();
		ob_end_clean(); 
		
		$recipients = get_option('admin_email');
		$attachments = array();
		
		if(wpufa_get_value_if_set($options, 'notify_attach_to_admin_email', "false") == "true") 
		{
			$files_data = $wpufa_upload_model->get_meta($upload_field_is, "_uploaded_files_data");
			foreach($files_data as $file_data)
				$attachments[] = $file_data['abs_path'];
		}
		if( wpufa_get_value_if_set($options, 'notifications_recipients', "") != "")
		{
			$recipients = wpufa_get_value_if_set($options, 'notifications_recipients', "");
		}
		
		wp_mail( $recipients, $subject, $message, "Content-Type: text/html\r\n", $attachments);
	}
	public function wp_mail_from_name($name) 
	{
		return get_bloginfo('name');
	}
	public function wp_mail_from($content_type) 
	{
		$server_headers = function_exists('apache_request_headers') ? apache_request_headers() : wcfa_apache_request_headers();
		$domain = isset($server_headers['Host']) ? $server_headers['Host'] : null ;
		if(!isset($domain) && isset($_SERVER['HTTP_HOST']))
			$domain = str_replace("www.", "", $_SERVER['HTTP_HOST'] );
		
		return isset($domain) ? 'noprely@'.$domain : $content_type;
	}
}
?>