<?php 
namespace WPUFA\classes\com;

class File
{
	var $to_remove_from_file_name = array(".php", "../", "./",  ".jsp", ".vbs", ".exe", ".bat", ".php5", ".pht", ".phtml", 
										  ".shtml", ".asa", ".cer", ".asax", ".swf", ".xap", ";", ".asp", ".aspx", 
										  "*", "<", ">", "::");
	public function __construct()
	{
		add_action('wp_ajax_wpufa_file_chunk_upload', array($this,'ajax_manage_file_chunk_upload'));
		add_action('wp_ajax_nopriv_wpufa_file_chunk_upload', array($this,'ajax_manage_file_chunk_upload'));
		//init actions
		add_action('init', array($this,'get_file_in_zip'));
		add_action( 'init', array( $this, 'delete_tmp_files' ));
	}
	public function get_temp_dir_path($unique_id = null, $baseurl = false)
	{
		$upload_dir = wp_upload_dir();
		$temp_dir = !$baseurl ? $upload_dir['basedir']. '/wpufa/' : $upload_dir['baseurl']. '/wpufa/';
		$temp_dir .= isset($unique_id) && $unique_id !=0 ? $unique_id.'/': 'tmp/';
		
		if(!$baseurl)
		{
			if (!file_exists($temp_dir)) 
					mkdir($temp_dir, 0775, true);
			
			if( !file_exists ($temp_dir.'index.html'))
				$this->create_empty_file  ($temp_dir.'index.html');
		}
		return $temp_dir;
	}
	private function create_empty_file($path)
	{
		$file = fopen($path, 'w'); 
		fclose($file); 
	}
	public function ajax_manage_file_chunk_upload()
	{
		global $wpufa_file_model;
		global $wpufa_session_model ;
		
		if(!isset($_POST['wpufa_field_id']) || 
		  !isset($_FILES['wpufa_file_chunk']) || 
		  !isset($_POST['wpufa_field_id']) || 
		  !wp_verify_nonce( wpufa_get_value_if_set($_POST, 'wpufa_security', ""), 'wpufa_security_'.$_POST['wpufa_field_id'] ))
			wp_die();
		
		$buffer = 5242880; //1048576; //1mb
		$target_path = $this->get_temp_dir_path();
		$tmp_name = $_FILES['wpufa_file_chunk']['tmp_name'];
		$size = $_FILES['wpufa_file_chunk']['size'];
		$current_chunk_num = $_POST['wpufa_current_chunk_num'];
		//validation
		$file_name = str_replace($this->to_remove_from_file_name, "",$_POST['wpufa_file_name']);
		$session_id =  str_replace($this->to_remove_from_file_name, "", $_POST['wpufa_current_upload_session_id']);
		$field_id = str_replace($this->to_remove_from_file_name, "", $_POST['wpufa_field_id']);
		if($file_name != $_POST['wpufa_file_name'] || $session_id != $_POST['wpufa_current_upload_session_id'] || $field_id != $_POST['wpufa_field_id'])
			wp_die();
		
		//
		$tmp_file_name = $session_id."_".$file_name;
		$wpufa_is_last_chunk = $_POST['wpufa_is_last_chunk'] == 'true' ? true : false;
	
		$com = fopen($target_path.$tmp_file_name, "ab");
		$in = fopen($tmp_name, "rb");
			if ( $in ) 
				while ( $buff = fread( $in, $buffer ) ) 
				   fwrite($com, $buff);
				 
			fclose($in);
		fclose($com);
		
		if($wpufa_is_last_chunk && file_exists($target_path.$tmp_file_name))
		{
			$validate = wp_check_filetype_and_ext($target_path.$tmp_file_name, $_POST['wpufa_file_name'] );
			$real_filename = $validate['proper_filename'] !== false ? $validate['proper_filename'] : $_POST['wpufa_file_name'];
			foreach($this->to_remove_from_file_name as $needle)
			{
				$pos = strpos($real_filename, $needle);
				$pos2 = strpos($file_name, $needle); //??
				if ($pos !== false || $pos2 !== false)  
				{
					unlink($target_path.$tmp_file_name);
					break;
				}
			}
				
		}
		wp_die();
	}
	public function return_bytes($val) 
	{
		$val = trim($val);
		$last = strtolower($val[strlen($val)-1]);
		$val = intval (substr($val, 0, -1));
		
		switch($last) {
			// The 'G' modifier is available since PHP 5.1.0
			case 'g':
				//$val *= 1024;
				$val *= 1024 * 1024 * 1024;
			case 'm':
				$val *= 1024 * 1024 ;
				break;
			case 'k':
				$val = 1024;
		}
		
		return $val;
	}
	public function get_php_settings($setting_name = null)
	{
		$result = array();
		$result['post_max_size'] = ini_get('post_max_size');
		$result['upload_max_filesize'] = ini_get('upload_max_filesize');
		$result['max_file_uploads'] = ini_get('max_file_uploads');
		
		$result['size_that_can_be_posted'] = $result['post_max_size'] < $result['upload_max_filesize'] ? $result['post_max_size'] : $result['upload_max_filesize'];
		
		return isset($setting_name) && isset($result[$setting_name]) ? $result[$setting_name] : $result;
	}
	public function move_file_after_upload($session_id, $upload_id, $files)
	{
		$upload_dir = wp_upload_dir();
		$sub_path = apply_filters('wpufa_storage_folder_name', '/wpufa/'.$upload_id."/", $upload_id);
		$upload_dir = $upload_dir['basedir']. $sub_path;
		$temp_dir = $this->get_temp_dir_path();
		$uploaded_files = array();
		
		if (!file_exists($upload_dir)) 
			mkdir($upload_dir, 0775, true);
		
		if( !file_exists ($upload_dir.'index.html'))
			$this->create_empty_file  ($upload_dir.'index.html');
		
		foreach($files as $file_to_move)
		{
			$uploaded_files[] = array('abs_path' => $upload_dir.$file_to_move, 'rel_path' => $sub_path, 'name' =>$file_to_move);
			rename($temp_dir.$session_id."_".$file_to_move, $upload_dir.$file_to_move);
		}
		
		return $uploaded_files;
	}
	public function delete_file($file_relative_path)
	{
		$upload_dir = wp_upload_dir();
		try{
			@unlink($upload_dir['basedir'].'/'.$file_relative_path);
		}catch(Exception $e){};
	}
	public function delete_directory($upload_id)
	{
		$upload_dir = wp_upload_dir();
		$dir = $upload_dir['basedir'].'/wpufa/'.$upload_id;
		if(!file_exists($dir))
			return;
		try{
			
			$it = new \RecursiveDirectoryIterator($dir, \RecursiveDirectoryIterator::SKIP_DOTS);
			$files = new \RecursiveIteratorIterator($it,
						 \RecursiveIteratorIterator::CHILD_FIRST);
						 
			
			foreach($files as $file) {
				if ($file->isDir()){
					@rmdir($file->getRealPath());
				} else {
					@unlink($file->getRealPath());
				}
			}
			@rmdir($dir);
		}
		catch(UnexpectedValueException $e){}
	}
	public function delete_tmp_files() 
	{
		$max_time = 2400; //1200: 60 min
		$upload_dir = wp_upload_dir();
		$temp_dir = $upload_dir['basedir']. '/wpufa/tmp/';
		$files = glob($temp_dir."*");
		
		if(is_array($files) && count($files) > 0)
		{
			foreach ($files as $file) 
			{
				if (basename($file) != "index.html" && @filemtime($file) < time() - ($max_time)) //No need to multiply for 60, it is already done in the Options model. 86400:24h, 14400:4h, 10800:3h, 1800: 30 min 
				{
					
					try{
						
						@unlink($file);
					}catch(Exception $e){};
				}
			}
		}
	}
	function is_image($path)
	{
		$a = getimagesize($path);
		if(!$a)
			return false;
		$image_type = $a[2];
		
		if(in_array($image_type , array(IMAGETYPE_GIF , IMAGETYPE_JPEG ,IMAGETYPE_PNG , IMAGETYPE_BMP)))
		{
			return true;
		}
		return false;
	}
	public function get_file_in_zip() 
	{
		if(!isset($_GET['wpufa_field_id']) || !class_exists('ZipArchive'))
			return;
		
		global $wpufa_upload_model;
		
		$files_to_zip = $wpufa_upload_model->get_meta($_GET['wpufa_field_id'], "_uploaded_files_data");
		
		$zip = new \ZipArchive();
		$filename = @tempnam("tmp", "zip");
		if (empty($files_to_zip) || $zip->open($filename, \ZipArchive::OVERWRITE)!==TRUE) 
		{
			return;
		}
		foreach($files_to_zip as $file_data)
		{
			
			$zip->addFile($file_data['abs_path'], $file_data['name']);
		}
		
		$zip->close();			
		header('Content-Type: application/zip');
		header('Content-Length: ' . filesize($filename));
		header('Content-Disposition: attachment; filename="Files.zip"');
		
		//File read
		$handle = fopen($filename, 'rb'); 
		$buffer = ''; 
		while (!feof($handle)) 
		{ 
			$buffer = fread($handle, 4096); 
			echo $buffer; 
			@ob_flush(); 
			flush(); 
		} 
		fclose($handle); 
		  
		unlink($filename); 
		die();
	}
}
?>