var wpufa_free_field_id = 0;
jQuery(document).ready(function()
{ 
	"use strict";
	wpufa_free_field_id = parseInt(wpufa.next_id);
	jQuery(document).on('click', '.wpufa_add_new_button', wpufa_add_new_upload_field);
	jQuery(document).on('click', '.wpufa_collapse_options', wpufa_manage_options_area_display)
	jQuery(document).on('click', '.wpufa_remove_field', wpufa_delete_field)
	jQuery(document).on('click', '.wpufa_add_new_input_field_button', wpufa_on_add_input_field)
	jQuery(document).on('click', '.master_option', wpufa_manage_master_option);
	jQuery(document).on('click', '.wpufa_remove_input_field_button', wpufa_remove_input_field);
	jQuery(document).on('click', '.expand-field', wpufa_expand_input_field_option_area);
	jQuery(document).on('click', '.remove-field', wpufa_remove_input_field_option_area);
	jQuery(document).on('click','.duplicate_field', wpufa_duplicate_field);
	
	//init
	wpufa_manage_master_option(null);
	wpufa_manage_save_button_display(0);
	wpufa_init_drag_and_drop();
	wpufa_init_date_and_fields();
	
	try
	{
		if(jQuery(".wpufa_sortable").length > 0)
			 jQuery(".wpufa_sortable").sortable({
				containment: "parent", 
				handle: ".wpufa_sort_button",
				 cancel: '',
				placeholder: "ui-state-highlight",
				
			});
	}catch(error){jQuery('.wpufa_sort_button').hide();}
});
function wpufa_init_date_and_fields()
{
	jQuery('.wpufa_time_field').each(function(index, elem)
	{
		var min = jQuery(elem).data('min');
		var max = jQuery(elem).data('max');
		var time_interval = jQuery(elem).data('interval');
		min = min != null ? min.split(",") : "";
		max = max != null ? max.split(",") : "";
		jQuery(elem).pickatime({
		  format: 'HH:i', //ToDo: wpufa_options.time_format,
		  formatSubmit: 'HH:i',
		   hiddenSuffix: '',
		   min: min,
		   max: max,
		   interval:time_interval
			
		});
	});
	
	jQuery('.wpufa_date_field').each(function(index, elem)
	{
		var min = jQuery(elem).data('min');
		var max = jQuery(elem).data('max');
		var days_to_disable = jQuery(elem).data('disabled-days')+"";
		var specific_dates_to_disable = jQuery(elem).data('specific-dates-to-disable')+"";
		min = min != null ? min.split(",") : "";
		max = max != null ? max.split(",") : "";
		if(max != "")
			max[1] = max[1] - 1 ;
		if(min != "")
			min[1] = min[1] - 1 ;
		
		if(days_to_disable == "none" || days_to_disable == null)
			days_to_disable = [];
		else 
		{
			var day_values = days_to_disable.split(",");
			days_to_disable = [];
			for(var i = 0; i < day_values.length; i++)
				days_to_disable.push(parseInt(day_values[i]));
		
		}
		
		if(specific_dates_to_disable != "" && specific_dates_to_disable != "undefined")
		{
			var dates = specific_dates_to_disable.split(";");
			for(var i = 0; i < dates.length; i++)
				days_to_disable.push(dates[i].split(","));
		}
		
		jQuery(elem).pickadate({
			 firstDay: 1,
			 format: 'yyyy-mm-dd', //Todo: wpufa_options.date_format
			 formatSubmit: 'yyyy-mm-dd',
			 hiddenSuffix: '',
			 min: min,
			 max: max,
			 selectYears: 300,
			 selectMonths: true,
			 klass: {
				 selectMonth: 'wpufa_picker__select--month',
				 selectYear: 'wpufa_picker__select--year'
			 },
			 disable: days_to_disable
			
		});
	});
}
function wpufa_init_drag_and_drop()
{
	
	jQuery('.wpufa_input_fields_container').sortable({
		connectWith: '.wpufa_input_fields_container',
		handle: '.wpufa_title_and_controllers_container',
		cursor: 'move',
		placeholder: 'placeholder',
		forcePlaceholderSize: true,
		opacity: 0.4,
		stop: function(event, ui)
		{
			
		}
	})
	.disableSelection();
}
function wpufa_expand_input_field_option_area(event)
{
	event.preventDefault();
	const id = jQuery(event.currentTarget).data('id');
	
	jQuery('#wpufa_input_field_options_container_'+id).toggle();
	
	return false;
}
function wpufa_remove_input_field_option_area(event)
{
	event.preventDefault();
	const id = jQuery(event.currentTarget).data('id');
	const elem = jQuery('#wpufa_input_field_container_'+id);
	if(confirm(wpufa.confirm_delete_message))
		elem.fadeOut(200, function(){elem.remove()});
	
	return false;
}
function wpufa_manage_master_option(event)
{
	const transition_time = event == null ? 0 : 300;
	
	jQuery('.master_option').each(function(index, elem)
	{
		if(jQuery(elem).is(':checkbox'))
		{
			const hide_process_result = elem.checked ? jQuery(".master_related_"+jQuery(elem).data('related-id')).fadeIn(transition_time) : jQuery(".master_related_"+jQuery(elem).data('related-id')).fadeOut(transition_time);
		}
	});
}
function wpufa_on_add_input_field(event)
{
	event.preventDefault();
	const id = jQuery(event.currentTarget).data('id');
	const type = jQuery("#wpufa_input_fields_type_"+id).val();
	
	var formData = new FormData();
	formData.append('action', 'wpufa_add_new_input_field'); 
	formData.append('upload_field_id', id); 
	formData.append('type', type); 
	formData.append('security', wpufa.security); 

	//UI
	wpufa_before_ajax_loading();
	
	jQuery.ajax({
		url: ajaxurl,
		type: 'POST',
		data: formData,
		async: true,
		success: function (response) 
		{
			//UI
			jQuery("#wpufa_input_fields_container_"+id).append(response);
			wpufa_manage_save_button_display(100);
			wpufa_after_ajax_loading();
			wpufa_init_date_and_fields();
			
		},
		error: function (data) 
		{
			
		},
		cache: false,
		contentType: false,
		processData: false
	});
	
	return false;
}
function wpufa_add_new_upload_field()
{
	
	var formData = new FormData();
	formData.append('action', 'wpufa_get_upload_field_configuration_template'); 
	formData.append('start_index', wpufa_free_field_id++); 
	formData.append('security', wpufa.security); 

	//UI
	wpufa_before_ajax_loading();
	
	jQuery.ajax({
		url: ajaxurl,
		type: 'POST',
		data: formData,
		async: true,
		success: function (response) 
		{
			//UI
			jQuery("#wpufa_upload_fields_container").append(response);
			//no need: wpufa_init_editor(wpufa_free_field_id);
			wpufa_manage_save_button_display(100);
			wpufa_after_ajax_loading();
			
		},
		error: function (data) 
		{
			
		},
		cache: false,
		contentType: false,
		processData: false
	});
	
	return false;
}
function wpufa_duplicate_field(event)
{
	event.preventDefault();
	event.stopImmediatePropagation();
		
	var random = Math.floor((Math.random() * 1000000) + 999);
	var formData = new FormData();
	var index_to_duplicate = jQuery(event.currentTarget).data('id');
	formData.append('action', 'wpufa_duplicate_field'); 
	formData.append('start_index', wpufa_free_field_id++); 
	formData.append('index_to_duplicate', index_to_duplicate); 
	formData.append('security', wpufa.security); 
	
	//UI
	wpufa_before_ajax_loading();
	
	jQuery.ajax({
		url: ajaxurl+"?nocache="+random,
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) 
		{
			//UI	
			jQuery("#wpufa_upload_fields_container").append(data);	
			wpufa_manage_save_button_display(100);
			wpufa_after_ajax_loading();
			
			//init
			/* wpufa_checkMultipleUpoloadsCheckbox();
			jQuery(".upload_type").trigger('change'); */
		},
		error: function (data) 
		{
			
		},
		cache: false,
		contentType: false,
		processData: false
	});	
}
function wpufa_init_editor(field_id)
{
	for(var i = 0; i < wpufa.available_langs.length; i++)
	{
		tinyMCE.execCommand( 'mceAddEditor', true, 'wpufa_field_description_editor_'+field_id+'_'+wpufa.available_langs[i] );
	}
}
function wpufa_manage_options_area_display(event)
{
	const id = jQuery(event.currentTarget).data('id');
	jQuery('#wpuef_show_options_button_'+id).text(jQuery('#wpufa_options_container_'+id).css('display') == 'none' ? wpufa.hide_options: wpufa.show_options);
	jQuery('#wpufa_options_container_'+id).fadeToggle();
	
	
	return false;
}
function wpufa_remove_input_field(event)
{
	const id = jQuery(event.currentTarget).data('id');
	if(confirm(wpufa.confirm_delete_message))
	{
		jQuery('#wpufa_input_field_container_'+id).fadeOut(300, function() { jQuery(this).remove(); });
	}
	return false;
}
function wpufa_delete_field(event)
{
	const id = jQuery(event.currentTarget).data('id');
	if(confirm(wpufa.confirm_delete_message))
	{
		jQuery('#wpufa_field_container_'+id).fadeOut(300, function() { jQuery(this).remove(); });
	}
	return false;
}
function wpufa_manage_save_button_display(fadeOut)
{
	if(jQuery("#wpufa_upload_fields_container").children().length == 0)
		jQuery('.wpufa_save_button').fadeOut(fadeOut);
	else
		jQuery('.wpufa_save_button').fadeIn()
}
function wpufa_before_ajax_loading()
{
	jQuery(".disable_during_animation").attr('disabled', true);
	jQuery(".load_new_upload_field_spinner, .load_new_input_field_spinner").addClass('is-active');
}
function wpufa_after_ajax_loading()
{
	jQuery(".disable_during_animation").removeAttr('disabled');
	jQuery(".load_new_upload_field_spinner, .load_new_input_field_spinner").removeClass('is-active');
}