"use strict";
var wpufa_num_uploads = 0;
jQuery(document).ready(function()
{
	jQuery(document).on('click', '.wpufa_view_download_file_button', wpufa_view_download_file);
	jQuery(document).on('click','.wpufa-upload-button', wpufa_upload_file);
	jQuery(document).on('click','.wpufa_file_tmp_delete_button', wpufa_delete_tmp_file);
	document.addEventListener('onwpufaMultipleFileUploaderComplete', wpufa_upload_ended);
	
});


function wpufa_view_download_file(evt)
{
	evt.stopPropagation();
	evt.preventDefault();
	var href =  jQuery(evt.currentTarget).data('href');
	var win = window.open(href, '_blank');
	return false;
}

function wpufa_check_file_size_and_ext(id, files, single_min_size, single_max_size, sum_min_size, sum_max_size, extension_accepted)
{
	var error_message_to_show = "";
	var total_size = 0;
	var max_size_text = (single_max_size/1024) < 1 ? Math.floor(single_max_size)+"kb" : Math.floor(single_max_size/1024)+"Mb";
	var min_size_text = (single_min_size/1024) < 1 ? Math.floor(single_min_size)+"kb" : Math.floor(single_min_size/1024)+"Mb";
	var sum_min_size_text = (sum_min_size/1024) < 1 ? Math.floor(sum_min_size)+"kb" : Math.floor(sum_min_size/1024)+"Mb";								
	var sum_max_size_text = (sum_max_size/1024) < 1 ? Math.floor(sum_max_size)+"kb" : Math.floor(sum_max_size/1024)+"Mb";	
	extension_accepted = extension_accepted != undefined && extension_accepted != "" ? extension_accepted.toLowerCase() : "";
	//size
	if (window.File && window.FileReader && window.FileList && window.Blob)
	{
		if(files != undefined)
		{
			for(var i=0; i<files.length; i++)
			{
				var fsize =files[i].size/1024; //files[0].size is expressed in byte. single_max_size in kbyte
				var ftype = files[i].type;
				var fname = files[i].name;
				var fext = files[i].name.split('.').pop().toLowerCase();
				total_size += fsize;
				
				var size = fsize/1048576; // 1MB in bytes
				size = size.toFixed(2);
				
				if(single_max_size != 0 && fsize > single_max_size)
				{
					error_message_to_show += fname+" "+wpufa[id].file_size_error+max_size_text+"\n";
				}
				if(single_min_size != 0 && fsize < single_min_size)
				{
					error_message_to_show += fname+" "+wpufa[id].file_min_size_error+min_size_text+"\n";
				}
				
				//extension
				if(extension_accepted != undefined && extension_accepted != "" && extension_accepted.indexOf(fext) == -1)
				{
					error_message_to_show += fname+" "+wpufa[id].extension_error+"\n";
					
				}
				
				error_message_to_show += error_message_to_show != "" ? "\n" : "";
			}
			
			if(sum_min_size != 0 && total_size < sum_min_size)
			{
				error_message_to_show += wpufa[id].file_sum_min_size_error+sum_min_size_text+"\n";
			}
			if(sum_max_size != 0 && total_size > sum_max_size)
			{
				error_message_to_show += wpufa[id].file_sum_size_error+sum_max_size_text+"\n";
			}	
			
		}
	}
	else{
		alert(wpufa[id].browser_compliant_error);
		return false;
	}
	
	
	
	if(error_message_to_show != "")
	{
		alert(error_message_to_show);
		return false;
	}
	return true;
}

function wpufa_reset_upload_field_metadata(id)
{
	jQuery('#wpufa_file_tmp_delete_button_'+id).hide();
	jQuery('#wpufa_file_tmp_delete_button_'+id).data('file-to-delete', "");
	jQuery('#wpufa-filename-'+id).val("");
	jQuery('#wpufa-complete-name-'+id).val("");
    jQuery('#wpufa-filenameprefix-'+id).val("");
}
function wpufa_upload_file(evt)
{
	evt.preventDefault();
	evt.stopPropagation();
	
	var id =  jQuery(evt.currentTarget).data('id');
	var upload_field_id =  id.split("-");
	var files_array = new Array();
	
	//Object to array 
	Object.entries(wpufa_files_list[id]).forEach(entry => {
	  const [key, value] = entry;
	  files_array.push(value);
	});

	//Input fields check 
	var missing_required_field = false;
	var formData = new FormData();
	formData.append('action', 'wpufa_finalize_upload_process');
	formData.append('security', wpufa[id].security);
	formData.append('upload_field_id', upload_field_id[0]);
	formData.append('upload_field_unique_id', id);
	
	
	jQuery('.wpufa_input_field_'+id).each(function(index, elem) 
	{
		const type = jQuery(elem).data('type');
		const value = type == 'checkbox' ? jQuery(elem).prop('checked') : jQuery(elem).val();
		const input_field_id = jQuery(elem).data('input-field-id');
		const required = jQuery(elem).attr('required') != undefined;
		const tag_name = jQuery(elem).prop("tagName").toLowerCase();
		
		if(type == 'checkbox')
			missing_required_field = !value && required ? true : missing_required_field;
		else
			missing_required_field = value == "" && required ? true : missing_required_field;
		
		formData.append("input_fields["+input_field_id+"]", value);
	});
	
	if(missing_required_field)
	{
		alert(wpufa[id].missing_required_filed);
		return;
	}
		
	
	var id =  jQuery(evt.currentTarget).data('id');
	var single_min_size =  jQuery(evt.currentTarget).data('single-min-size');
	var single_max_size =  jQuery(evt.currentTarget).data('single-max-size');
	var sum_min_size =  jQuery(evt.currentTarget).data('sum-min-size');
	var sum_max_size =  jQuery(evt.currentTarget).data('sum-max-size');
	var extension_accepted = jQuery(evt.currentTarget).data('extension-accepted');
	
	if(!wpufa_check_file_size_and_ext(id, files_array, single_min_size, single_max_size, sum_min_size, sum_max_size, extension_accepted))
		return;
	
	var file = files_array[0];
	
	jQuery('.wpufa-to-disable-while-uploading').fadeOut();
	jQuery('#wpufa_upload_progress_status_container_'+id).fadeIn();
	
	wpufa_num_uploads++;
	
   
   var current_upload_session_id = Math.floor((Math.random() * 10000000) + 1);
   var tempfile_name  = wpufa_replace_bad_char(file.name);

   var multiple_file_uploader = new wpufaMultipleFileUploader({ field_id:id, 
																ajaxurl: wpufa[id].ajax_url, 
																files: files_array, 
																file: file, 
																file_name:tempfile_name,
																upload_input_field:"none",
																security: wpufa[id].security,
																form_data: formData,
																current_upload_session_id: current_upload_session_id});
   
	multiple_file_uploader.continueUploading();						
	return false;
			
}
function wpufa_upload_ended(event)
{
	//UI
	wpufa_num_uploads--;
	var id = event.field_id;
	var form_data = event.form_data;
	var files = new Array();
	
	for(var i = 0; i < event.files.length; i++)
		files.push(wpufa_replace_bad_char(event.files[i].name));
	
	form_data.append('files', files);
	form_data.append('session_id', event.current_upload_session_id);
	
	jQuery.ajax({
		url: wpufa[id].ajax_url,
		type: 'POST',
		data: form_data,
		async: true,
		success: function (data) 
		{
			//ToDo: show after upload message
			jQuery('#wpufa_main_container_'+id).fadeOut();
			jQuery('#wpufa_after_upload_container_'+id).fadeIn();
			
		},
		error: function (data) 
		{
			//console.log(data);
			//alert("Error: "+data);
		},
		cache: false,
		contentType: false,
		processData: false
	}); 
	
	return false;
}
function wpufa_delete_tmp_file(event)
{
	event.preventDefault();
	event.stopPropagation();

	var file_to_delete =  jQuery(event.currentTarget).data('file-to-delete');
	var id =  jQuery(event.currentTarget).data('id');
	
	
	jQuery(event.currentTarget).fadeOut();
	if(file_to_delete == "")
		return false;
	
	//UI
	jQuery("#wpufa_input_file_"+id).fadeIn();
	jQuery("#wpufa_input_file_"+id).val("");
	jQuery("#wpufa-filename-"+id).val("");
	jQuery("#wpufa-filenameprefix-"+id).val("");
	jQuery("#wpufa-complete-name-"+id).val("");
	jQuery("#wpufa_input_file_-"+id).val("");
	
	var formData = new FormData();
	formData.append('action', 'wpufa_delete_tmp_uploaded_file');
	formData.append('file_to_delete', file_to_delete);
	
	jQuery.ajax({
		url: wpufa.ajaxurl,
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) 
		{
			
		},
		error: function (data) 
		{
			//console.log(data);
			//alert("Error: "+data);
		},
		cache: false,
		contentType: false,
		processData: false
	}); 
	return false;
}
function wpufa_replace_bad_char(text)
{
	text = text.replace(/'/g,"");
	text = text.replace(/"/g,"");
	text = text.replace(/ /g,"_");
	
	var remove_special_chars = true;
	var translate_re = /[öäüÖÄÜ]/g;
	var translate = {
		"ä": "a", "ö": "o", "ü": "u",
		"Ä": "A", "Ö": "O", "Ü": "U",
		"ß": "ss" // probably more to come
	  };
	text = text.replace(translate_re, function(match) { 
      return translate[match]; 
    });
	
	/* if(remove_special_chars)
	{
		text = text.replace(/[^0-9a-zA-Z_.]/g, '');
	} */
	
	text = text == "" ? 'file' : text;
	return text;
}