<?php 
//Version: 1.1


//Anonymous user
if(wpufa_get_value_if_set($upload_fields_data, 'anonymous_upload', "false") == "false" && get_current_user_id() == 0): ?>
<h4><?php esc_html_e('You need to perform the login in order to access the upload controller.','wordpress-upload-files-anywhere');?></h4>
<?php return;
endif; 
//End

//Multiple submissions
if(wpufa_get_value_if_set($upload_fields_data, 'single_submission', "false") == "true"):
	  if(get_current_user_id() == 0): ?>
		<h4><?php esc_html_e('You need to perform the login in order to access the upload controller.','wordpress-upload-files-anywhere');?></h4>
<?php return; 
		elseif(!$wpufa_user_model->can_user_perform_the_upload($field_id)): ?>
		<h4><?php esc_html_e('You cannot perform any other upload.','wordpress-upload-files-anywhere');?></h4>
<?php 	return; 
		endif;	
endif 
//End
?>
<div class="wpufa_main_container" id="wpufa_main_container_<?php echo $unique_id; ?>" style=" width:<?php echo wpufa_get_value_if_set($upload_fields_data, array('main_container', 'width'), "100%", true); ?>">
	
	<!-- Upload fields before -->
	<div class="wpufa_before_input_field_container" id="wpufa_before_input_field_container_<?php echo $unique_id; ?>">
	<?php 
		$wpufa_html_model->render_input_fields($before_input_fields, $unique_id);
		?>
	</div>
	<!-- Upload area -->
	<div class="drop-zone" data-id="<?php echo $unique_id; ?>" data-is-multiple="<?php echo wpufa_get_value_if_set($upload_fields_data, 'enable_multiple_uploads_per_field', false) ? "true" : "false";?>">
	<span class="drop-zone__prompt"><?php esc_html_e('Drop file or click to upload','wordpress-upload-files-anywhere');?></span>
	<input type="file" 
			name="myFile" 
			class="drop-zone__input"   
			data-id="<?php echo esc_attr($unique_id); ?>" 
			accept="<?php echo esc_attr($upload_fields_data['types']); ?>"			
			id="wpufa_input_file_<?php echo  esc_attr($unique_id);?>" 
			<?php if(wpufa_get_value_if_set($upload_fields_data, 'enable_multiple_uploads_per_field', false)) echo "multiple";?> />
	</div>
	<p class="wpufa_description">
	<?php echo $upload_fields_data['description'][$current_lang]; ?>
	</p>
	
	<!-- Input fields after -->
	<div class="wpufa_after_input_field_container" id="wpufa_after_input_field_container_<?php echo $unique_id; ?>">
	<?php $wpufa_html_model->render_input_fields($after_input_fields, $unique_id); ?>
	</div>
	<!-- End input fields after -->

	<!-- Upload progress managment -->
	<div id="wpufa_upload_progress_status_container_<?php echo  $unique_id; ?>" class="wpufa_upload_progress_status_container">
		<div class="wpufa_upload_progressbar" id="wpufa_upload_progressbar_<?php echo  $unique_id; ?>"></div >
		<div class="wpufa_upload_progressbar_percent" id="wpufa_upload_progressbar_percent_<?php echo  $unique_id; ?>">0%</div>
	</div>
	<button class="button wpufa-upload-button wpufa-to-disable-while-uploading" 
			id="wpufa-upload-button-<?php echo $unique_id; ?>" 
			data-id="<?php echo esc_attr($unique_id); ?>"
			data-extension-accepted="<?php echo esc_attr($upload_fields_data['types']); ?>"
			data-single-min-size = "<?php echo esc_attr(wpufa_get_value_if_set($upload_fields_data, 'min_size', 0)*1024); ?>"
			data-single-max-size = "<?php echo esc_attr(wpufa_get_value_if_set($upload_fields_data, 'max_size', 0)*1024); ?>"
			data-sum-min-size = "<?php echo esc_attr(wpufa_get_value_if_set($upload_fields_data, 'multiple_files_min_size_sum', 0)*1024);?>"
			data-sum-max-size = "<?php echo esc_attr(wpufa_get_value_if_set($upload_fields_data, 'multiple_files_max_size_sum', 0)*1024); ?>"><?php esc_html_e('Upload','wordpress-upload-files-anywhere');?></button>
	<!-- End upload area -->
</div>
<div class="wpufa_after_upload_container" id="wpufa_after_upload_container_<?php echo $unique_id; ?>">
<?php echo $upload_fields_data['message_already_uploaded'][$current_lang]; ?>
</div>